# This YAML configures Gitlb CI for test builds and deployment of VisNow project.
# Job 'test-build' builds VisNow and is executed on every push to 'develop' branch (it is not executed on scheduled pipelines).
# Job 'deploy-daily' builds VisNow, builds installers with InstallBuilder, and uploads installerts to FTP server. It is 
# executed only on the scheduled pipelines. The deployment execution is conditioned inside gitlab-ci-deploy.sh script. 
# Gitlab commit SHA vs. last build commit SHA stored in last_daily_build file is used to determine if a last deployed build 
# is up to date. 

variables:
    # This will suppress any download for dependencies and plugins or upload messages which would clutter the console log.
    # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
    MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
    # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
    # when running from the command line.
    # `installAtEnd` and `deployAtEnd` are only effective with recent version of the corresponding plugins.
    MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true"    
    # DOCKER_AUTH_CONFIG is a configuration variable for Container Registry authorization, to retrieve docker image.
    DOCKER_AUTH_CONFIG: "{\"auths\": {\"registry.gitlab.com\": {\"auth\": \"${REGISTRY_AUTH}\"}}}"


# Docker image from visnow.org/visnow-deploy-docker project is used.
image: "$CI_REGISTRY/visnow.org/visnow-deploy-docker/liberica-openjdk-17-installbuilder:latest"


# Cache downloaded maven dependencies and plugins between builds.
cache:
    paths:
        - .m2/repository
    

# For merge requests do not `deploy` but only run `verify`.
# See https://maven.apache.org/guides/introduction/introduction-to-the-lifecycle.html
.verify: &verify
  stage: test
  script:
    - 'mvn $MAVEN_CLI_OPTS verify'
  except:
    - develop


# Verify merge requests using JDK17
verify:jdk17:
  <<: *verify
  
  
# For `develop` branch run `mvn deploy` automatically.
deploy:jdk17:
  stage: deploy
  script:
    - if [ ! -f ci_settings.xml ];
        then echo "CI settings missing\!";
      fi
    - 'mvn $MAVEN_CLI_OPTS deploy -s ci_settings.xml'
    - ls -la target    
  only:
      refs:
          - develop
  except:
      refs:
          - schedules
    
# For scheduled runs deploy daily build automatically.            
deploy-daily:jdk17:
    stage: deploy
    needs:
        - project: $CI_PROJECT_PATH
          job: deploy-daily
          ref: develop
          artifacts: true
    script:
        - mvn -version
        - pwd
        - 'curl -L -f -o last_daily_build -H "JOB-TOKEN: $CI_JOB_TOKEN" https://gitlab.com/api/v4/projects/379451/jobs/artifacts/develop/raw/last_daily_build?job=deploy-daily:jdk17 || true'
        - ls -la
        - chmod +x gitlab-ci-deploy.sh
        - ./gitlab-ci-deploy.sh
        - echo $CI_COMMIT_SHA > last_daily_build
    artifacts:
        paths:
            - last_daily_build        
    only:
        refs:
            - schedules  
            
